/***************************************************************************
                          apollonsystemtray.cpp  -  description
                             -------------------
							 
    copyright            : (C) 2002 by Martin Koebele
    email                : martin@mkoebele.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef APOLLONSYSTEMTRAYGNOME_H
#define APOLLONSYSTEMTRAYGNOME_H

#include <qpixmap.h>
#include <qstring.h>

#include "trayicon.h"

class KMainWindow;
class KPopupMenu;

class ApollonSystemTrayGnome : public TrayIcon
{
	Q_OBJECT

	public:
		ApollonSystemTrayGnome(QWidget *parent = 0, const char *name = 0);
		~ApollonSystemTrayGnome();

	public slots:
		void statsUpdate(int activeDownloads, float rate);

	private:
		KMainWindow *m_parent;
		KPopupMenu  *m_popupMenu;
		QPixmap m_icon;
		QString m_statusText;
		int     m_counter;
		int     m_activeDownloads;
		float   m_rate;
		bool    m_onAllDesktops;

	private slots:
		void activateOrHide(const QPoint &, int);
		void minimizeRestoreAction();
		void minimizeRestore(bool restore);
};

#endif
