#include <qstring.h>
#include <qmessagebox.h>

#include <kaboutdata.h>
#include <kapplication.h>
#include <kcmdlineargs.h>

#include "apollon.h"
#include "firstrun.h"

static KCmdLineOptions options[] = {  {"d", I18N_NOOP("switches on debug output"), 0} , { "s <argument>", I18N_NOOP("Connect to server host:port."), 0 } , { 0, 0, 0 }  };

int main( int argc, char **argv )
{
	KAboutData aboutData( "apollon", "Apollon", "0.9.2", "A giFT client for KDE", KAboutData::License_GPL, "(c) 2003, Bastiaan Naber \n(c) 2003, Martin Köbele \n(c) 2003, Arend van Beelen \n(c) 2002, Robert Wittams", 0, 0, "apollon-devel@lists.sourceforge.net");
	aboutData.addAuthor("Bastiaan Naber", 0, "bastiaan@ricardis.tudelft.nl");
	aboutData.addAuthor("Martin Köbele", 0, "apollon@mkoebele.de");
	aboutData.addAuthor("Arend van Beelen", 0, "arend@auton.nl");
	aboutData.addAuthor("Emre Uyguroglu", 0, "002415@students.emu.edu.tr");
	aboutData.addAuthor("Please contact us via the SourceForge mailinglist", 0, "apollon-devel@lists.sourceforge.net");


	KCmdLineArgs::init(argc, argv, &aboutData);

	KCmdLineArgs::addCmdLineOptions( options );

	KApplication a;

	FirstRunWizard wizard;

	if(wizard.checkFirstRun() == false)
		return 0;

	ApollonApp *apollon = new ApollonApp;

	a.setMainWidget( apollon );
	if (!apollon->startDocked())
	  apollon->show();

	return a.exec();
}
